OdeHack = {}

OdeHack.name = "OdeHack"

OdeHack.SavedVars = nil

OdeHack.ultimates = {
}

-- Change at your own risk. This value was arrived at after several days of testing.
local ODE_PING_DELAY = 2000

OdeHack.saved_defaults = {
    ["profiles"] = {
    }
}

function OdeHack.SendUltimate ()
    -- don't bother if not in a group

    if IsUnitGrouped("player") then
        local r1, r2, r3 = GetPlayerRoles()

        if r2 or r3 then
            -- find out how much ultimate we have
            -- we're only looking at war horn, too
            
            if GetUnitClass("player") == "Templar" then
                cost = 240
            else
                cost = 250
            end

            local current, max, effective_max = GetUnitPower("player", POWERTYPE_ULTIMATE)

            local pct = math.floor((current / cost) * 100) or 0


            PingMap(MAP_PIN_TYPE_PING, MAP_TYPE_LOCATION_CENTERED, pct/1000, pct/1000)
        end
    end

    zo_callLater(OdeHack.SendUltimate, 2000)
end

function OdeHack:Initialize()
    OdeHack.SavedVars = ZO_SavedVars:NewAccountWide("OdeHack_SavedVars", 1, "global", OdeHack.saved_defaults)

    zo_callLater(OdeHack.SendUltimate, 2000)
end


function OdeHack.OnAddOnLoaded(event, addonName)
    if addonName == OdeHack.name then
        OdeHack:Initialize()
    end
end

local function isempty (s)
    return s == nil or s == ''
end

local ULTIMATES_DISPLAYED = true

function OdeHack.ToggleUltimateDisplay ()
    ULTIMATES_DISPLAYED = not ULTIMATES_DISPLAYED

    OH_Ultimate:SetHidden(ULTIMATES_DISPLAYED)
end

function OdeHack.OnGroupChange (...)
    OdeHack.ultimates = {}
    OdeHack.UpdateUltimates()
end

function OdeHack.UpdateUltimates ()
    local label = "War Horn status:\n"

    for tag, data in pairs(OdeHack.ultimates) do
        local pct, timer = unpack(data)

        local now = GetTimeStamp()

        if (now - timer) < 5000 then 
            local name = GetUnitName(tag)

            if not isempty(name) then
                local color = ""
                local clear = ""

                -- determine their colour
                if pct >= 100 then
                    color = "|c00ff00"
                    clear = "|r"
                elseif pct >= 80 then
                    color = "|ccccc00"
                    clear = "|r"
                end

                label = label .. color .. name .. clear .. ": " .. pct .. "%\n"
            end
        end
    end

    OH_UltimateValues:SetText(label)
end

function OdeHack.OnMapPing (event, etype, pingtype, pingtag, offsetx, offsety, islocalplayerowner)
    if offsetx == offsety then
        local pct = offsetx * 1000
        if pct >= 0 then
            OdeHack.ultimates[pingtag] = {math.ceil(pct), GetTimeStamp()}
            OdeHack.UpdateUltimates()
        end
    end
end

function OdeHack.OdeHack (options)
    OdeHack.ToggleUltimateDisplay()
end

SLASH_COMMANDS["/odehack"] = OdeHack.OdeHack

EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_MAP_PING, OdeHack.OnMapPing)
 
EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_ADD_ON_LOADED, OdeHack.OnAddOnLoaded)

EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_GROUP_MEMBER_JOINED, OdeHack.OnGroupChange)
EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_GROUP_MEMBER_LEFT, OdeHack.OnGroupChange)
EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_GROUP_UPDATE, OdeHack.OnGroupChange)
EVENT_MANAGER:RegisterForEvent(OdeHack.name, EVENT_UNIT_FRAME_UPDATE, OdeHack.OnGroupChange)
